*COMDECK HISTORY
 *L700*    ************************************************ 
 *L716*    ************************************************ 
 TCHA021  FTPS ABORTS WITH "FFSLFLH PROTOCOL VIOLATION".
  
          FTPS SUPPORT OF THIRD PARTY TRANSFER IS NOT 
          WORKING PROPERLY: 
          AFTER TOLD TO GO PASSIVE ON DATA CONNECTION,
          FTPS ALWAYS EXPECT TO RECEIVE A DATA TRANSFER 
          PROTOCOL ELEMENT SUCH AS APPE/LIST/NLST/RETR/STOR 
          BEFORE THE PASSIVE DATA CONNECTION COULD BE SATISFIED 
          I.E. RECEIVING OF TCPCI.
  
          THIS MODSET RESOLVES THE ABOVE PROBLEM IN THE 
          FOLLOWING MANNER: 
          FTPS SHOULD BE ABLE TO HANDLE DATA TRANSFER 
          PROTOCOL ELEMENTS AND TCPCI IN ANY ORDER. 
  
          THE FTP LAYER AND CONNECTION MANAGEMENT LAYER STATE 
          TABLES HAS BEEN UPDATED TO REFLECT THE CHANGES. 
  
          AML            07/18/88       TEXTFFS,FFSLCRP,FFSLCSH,
                                        FFSLFLH,FFSRPDT 
  
 TCH0005  FTP/NOS CANNOT ACCESS HOSTS FILE IF PACKNAM IN EFFECT 
  
          WHEN FTP ATTEMPTS TO ACCESS THE HOSTS FILE IT USES THE
          CURRENT FAMILY AND PACK NAME IN EFFECT. AS A RESULT IT
          CANNOT ACCESS THE FILE WHEN THE NON DEFAULT FAMILY OR 
          AN ALTERNATE PACK IS USED.
  
          THE SOLUTION IS TO HAVE *FTPI* ACCESS THE HOSTS FILE
          FROM THE CORRECT RESIDENCY. 
  
          CJR/AML        88/08/03       COMAPDT, TEXTFCS, FCSCCHC,
                                        FCSEPES, FCSIIHN, FCSIINI,
                                        FCSIPES 
                                        TEXTFFS, FFSEEFS, FFSIP,
                                        FFSIIPV, FFSIRHF, FFSLCIP,
                                        FFSLCSH 
 TCHA028  FTP JOB KEEPS RESUBMITTING WHEN HOST FILE NOT FOUND.
  
          PROBLEM:  
          DURING INITIALIZATION, WHEN HOST FILE IS NOT FOUND, 
          FTP ABORTS ITSELF AND GOES INTO REPRIEVE PROCESSING 
          WHICH SPAWNS ANOTHER COPY OF ITSELF.
  
          SOLUTION: 
          IF HOST FILE IS NOT FOUND DURING INITIALIZATION,
          FTP WILL FLASH A MESSAGE ON THE B-DISPLAY PENDING 
          OPERATOR ACTION TO GO OR DROP THE FTP JOB.
          IN THE CASE OF DROPPING THE JSN, IT WILL BE END 
          OF STORY. 
          IN THE CASE OF GO THE JSN, THE OPERATOR HAS TO
          MAKE THE HOST FILE AVAILABLE, OR ELSE FTP WILL
          LOOP TRYING TO ACCESS THE FILE AND KEEP FLASHING
          THE MESSAGE ON THE B-DISPLAY. 
  
          AML            08/24/88        TEXTFFS,FFSIP,FFSIRHF
 TCHA029  FTPS - NOS FILE PARAMETER SS=NULL IS NOT WORKING. 
  
          PROBLEM IS CAUSED BY THE TOP BIT IN THE FET FOR 
          SS=NULL VALUE NOT SET.
  
          FTPS IS MODIFIED TO DEFINE THE NOS PARAMETER VALUES 
          PROPERLY WITH THE TOP BIT SET, AND REMOVE THE SETTING 
          OF THE TOP BIT IN THE COMPASS PFM INTERFACE ROUTINES. 
          THIS MODSET ALSO FIX PSR TTNA125 (RNFR/RNTO ALWAYS
          CHANGES THE ACCESS MODE TO READ). 
  
          AML            06/29/88       TEXTFFS,FFSIIPV,FFSLFLH 
                                        FFSUPCP,FFSUPFU 
  
 TCHA030  BATCH OUTPUT FOR *DISD* AND *DISFN* COMMANDS GARBLED
  
          FTP CLIENT GARBLES OUTPUT FROM THESE COMMANDS IN BATCH
          MODE. THIS MODSET CORRECTS THE PROBLEM BY SPACE FILLING 
          THE OUTPUT BUFFER AFTER SHIFTING THE DATA TO ALLOW FOR
          BATCH CARRIAGE CONTROL CHARACTERS AND SPACING.
  
          CJR            88/06/30       TEXTFCS, FCSOWOF
  
 TCHA031  FILE TRANSFER ABORTED DUE TO BAD SEQUENCE RESPONSE TO PASV
          PROTOCOL ELEMENT. 
  
          PROBLEM:  
          PRIOR TO THE PASV PROTOCOL ELEMENT, FTPI HAS JUST COMPLETED 
          A DATA TRANSFER SESSION.  AT THE COMPLETION OF DATA TRANSFER, 
          FTPI SENT A 226 TO FTP, THEN IT ISSUES A TCPD TO CLOSE THE
          DATA CONNECTION AND LEAVING ITSELF IN A STATE WAITING FOR 
          TCPDC.  MEANWHILE FTP SENT A PASV PROTOCOL ELEMENT TO FTPI, 
          AND FTPI DECLARES IT TO BE OUT OF SEQUENCE AND SENT A 503 TO
          FTP.  FTP IS EXPECTING A 227 FOR THE PASV PROTOCOL ELEMENT. 
          FTP TERMINATES UPON RECEIVING A 503.
  
          SOLUTION: 
          FTPI IS MODIFIED TO SEND THE 226 UPON RECEIVING OF TCPDC, 
          ONLY THEN THE DATA CONNECTION IS TRUELY CLOSED. 
          FTP LAYER STATE TABLE IS MODIFIED TO REFLECT THE CHANGES. 
  
          AML            06/28/88       TEXTFFS,FFSLFLH,FFSRCDT 
  
 TCHA032  DECK FFSCLST NEEDS TO XTEXT COMCZTB AS REQUIRED BY PRS
          NS22768.
          LTN    88/12/88    FFSCLST
  
 TCHA036  *FTPI* ABORTS WHEN ATTEMPTING TO TRANSFER A TAPE FILE 
  
          *FTPI* CHECKS THAT THE FILE BEING TRANSFERRED IS MASS 
          STORAGE RESIDENT AS WELL AS BEING LOCAL OR ATTACHED,
          AND ABORTS IF THIS IS NOT THE CASE. *FTP* MERELY CHECKS 
          THAT THE FILE BEING TRANSFERRED IS LOCAL OR ATTACHED. 
  
          THE SOLUTION IS TO HAVE *FTP* CHECK THAT THE FILE BEING 
          TRANSFERRED IS MASS STORAGE RESIDENT. 
  
          CJR            88/09/27       FCSUVFC 
  
 TCHA037  FTPI CANNOT ESTABLISH DATA CONNECTION WITH ANY FOREIGN HOSTS. 
  
          PROBLEM IS THAT FTPI PASSES AN INCORRECT SOURCE IP ADDRESS
          TO THE FOREIGN HOST CAUSING IT TO NOT BE ABLE TO ESTABLISH
          A DATA CONNECTION.  THIS PROBLEM IS INTRODUCED BY PSR 
          TCH0005.
  
          CORRECTIVE CODE SOLVES THE PROBLEM. 
  
          AML            09/14/88       TEXTFFS,FFSIP,FFSLFLH 
 TCHA038  FTPS ABORTS WITH FFSLFLH STATE 14 TRIGGER 40. 
  
          THIS IS CAUSED BY A QUIT COMMAND RECEIVED WHILE 
          WAITING FOR THE DATA CONNECTION TO BE CLOSED I.E. 
          PENDING TCPDC.
  
          THIS MODSET SOLVES THE PROBLEM IN SUCH A MANNER 
          THAT FTPS SHOULD BE ABLE TO HANDLE THE QUIT 
          COMMAND UNDER THIS CIRCUMSTANCE.
  
          AML            09/19/88       TEXTFFS,FFSLFLH 
  
 TCH0006  FTP/NOS USER VALIDATION PROBLEM 
  
          FTP/NOS REQUIRES THAT THE NOS VALIDATION BIT CALLED *CUCP*
          BE SET. THIS IS NOT REQUIRED BY OTHER FILE TRANSFER 
          APPLICATIONS AND OPENS A SECURITY PROBLEM.
  
          THE SOLUTION IS TO INCLUDE AN *SSJ=* ENTRY POINT AND NOS
          WILL NOT CHECK THE *CUCP* BIT.
  
          CJR            88/08/03       FTP 
  
 TCH0007  FTP PROTOCOL ERROR DETECTED 
  
          THE VAX VMS SYSTEM SENDS EACH FTP COMMAND/REPLY AS
          TWO TRANSMISSIONS, ONE THE COMMAND/REPLY AND THE OTHER
          THE TELNET END OF LINE TERMINATOR.  FTP/NOS ASSUMES 
          THAT THE TELNET END OF LINE TERMINATOR ALWAYS COMES IN
          THE SAME BLOCK AS THE COMMAND/REPLAY, CAUSING IT TO PROCESS 
          THE END OF LINE TERMINATOR AS SUBSEQUENT COMMAND/REPLAY.
  
          THE SOLUTION IS TO HAVE FTP/NOS WAIT FOR THE END
          OF LINE TERMINATOR OF EACH FTP COMMAND/REPLY. 
  
          NOTE:  THIS PSR IS DEPENDING ON PSR TCHA029.
  
          AML            08/19/88       TEXTFFS,FFSIIPV,FFSITIH,
                                        FFSXPES 
 TCHA039  FTPS/FTPI SENDS AN EXTRA REPLY CAUSING THINGS TO BE OUT 
          OF SYNC.
  
          UPON CLOSING OF DATA CONNECTION, FTPS/FTPI UNCONDITIONALLY
          SENDS A 226 CLOSING OF DATA CONNECTION MESSAGE CAUSING
          THINGS TO BE OUT OF SYNC. 
  
          THIS MODSET SOLVES THE PROBLEM SUCH THAT A 226 IS ONLY
          SENT WHENEVER IS APPROPRIATE. 
          THE FTP LAYER STATE TABLE HAS BEEN UPDATED TO REFLECT THE 
          CHANGES.
  
          AML            09/20/88       TEXTFFS,FFSIIPV,FFSLFLH 
  
 TCH0008  PROBLEM:  
          THERE WAS A CHARACTER CONVERSION PROBLEM ON FILES TRANSFERRED 
          TO FTP USING CS=8 AND CS=A CODESET OPTIONS. THE 8-BIT 
          CHARACTER 015B <CR> IS CORRUPTED UNLESS IT IS FOLLOWED BY 
          012B <LF>.
          SOLUTION: 
          FTPI/FTPS WAS NOT CORRECTLY BUILDING THE CHARACTER CONVERSION 
          TABLES TO HANDLE THE ESCAPE CHARACTER (015B) WHEN TRANSLATING 
          FROM ASCII88 TO 12-BIT ASCII8 OR 6/12 ASCII. THERE IS A 
          CORRESPONDING BUG IN FCOPY. 
  
          CMP 09/88  FFSCFIO. 
  
 TCH0009  FTP USER CAN ACCESS FAST ATTACH FILES 
  
          SINCE THE FTP SERVER HAS AN SSJ= ENTRY POINT, IT IS 
          POSSIBLE FOR A REMOTE FTP USER TO ACCESS FAST ATTACH
          FILES.
  
          THE SOLUTION IS TO ADD THE NF PARRAMETER TO THE ATTACH
          INTERFACE TO EXCLUDE THE ATTACHING OF FAST ATTACH FILES.
  
          CJR            88/09/02       FFSUPFU 
  
 *L727*    ************************************************ 
 S5524   THIS IS THE FTP PORTION OF THE "FTP, TCP ... PERFORMAMCE 
         ENHANCEMENTS" CODE AS DESCRIBED IN DAP S5524. IT BASICLY 
         DOES THE FOLLOWING TWO THINGS: 
  
         1. CHANGE THE BLOCK TYPE OF ALL OUTPUT DATA BLOCKS (EXCEPT 
            THE LAST ONE) FROM MSG TO BLK.
         2. IT ELIMINATES THE COPYING OF THE DATA BLOCKS TO THE WAIT
            QUEUE WHEN THE OUTSTANDING BLOCK COUNT OF THE DATA CON- 
            NECTION REACHES ITS LIMIT. SINCE FTP AT MOST QUEUES 
            ONE BLOCK OF DATA FOR THE DATA CONNECTION, A TWO-ALTERNATE- 
            BUFFER SCHEME HAS BEEN ADOPTED FOR THIS PURPOSE.
  
         CMP, TET     05/26/88  TEXTFFS, FFSCFIO, FFSIIPV, FFSOOBN, 
                                FFSSPFA, FFSLTIP, FFSLCSH, FFSUPEF, 
                                FFSUSOB.
 TCHA042  PUT OF A FILE WITH NON-EXISTANT REMOTE FILE AND 'UN' SPECIFIED
          CAUSED FOREIGN CLIENT TO BE OUT OF SYNC.
  
          FTP/NOS SERVER UPON PROCESSING OF A STOR OR APPE COMMAND WITH 
          FILE NON-EXISTANT AND 'UN' SPECIFIED INSTEAD OF SENDING A 550 
          SAYING THAT 'UN' PARAMETER IS INVALID, IT SENDS AN EXTRA 550
          CAUSING THE FOREIGN CLIENT TO GO OUT OF SYNC. 
  
          THIS MODSET SOLVES THE PROBLEM. 
  
          AML            11/01/88        FFSRPDT,FFSLFLH
 TCHA043  ATTEMPT TO GET EMPTY BINARY FILE RESULTS IN CONNECTION RESET. 
  
          ATTEMPT TO GET AN EMPTY FILE WITH ONLY A CONTROL RECORD 
          SUFFIXED IN BINARY MODE FROM ANY FOREIGN CLIENT TAKES 
          FTP/NOS SERVER DOWN.  THIS IS A LEGITIMATE TRANSFER,
          AND FTP SERVER SHOULD STRIP OFF THE CONTROL RECORD
          AND TRANSFER THE FILE AS AN EMPTY FILE TO THE FOREIGN 
          MACHINE.
  
          THIS MODSET SOLVES THE PROBLEM. 
  
          AML            11/01/88       FFSUPEF 
  
 TCHA052  FTPI ABORTS AFTER CONCB: STATE=8 TRIG=15 AND
          STATE=6 TRIG=16 
  
          THE PROBLEM IS CAUSED BY CODING ERRORS IN THE 
          TRANSLATION OF THE STATE TABLES TO THE CODE.
  
          THE STATE TABLES IN THE CODE ARE CORRECTED TO 
          REFLECT THE PROPER VALUES.
  
          KPH            04/19/89       FFSLCSH 
 TCH0012  *PFM* ERROR MESSAGES SHOWING UP IN USER DAYFILE.
  
          THE PERMANENT FILE ERROR MESSAGE PRODUCED WHEN CALLING
          *FATTACH* AND *FGET* ARE SHOWING UP IN THE USER DAYFILE.
  
          THE SOLUTION IS TO SET AN ERROR MESSAGE ADDRESS IN THE
          FET PRIOR TO THE *ATTACH* OR *GET*.  THIS WILL WRITE THE
          ERROR MESSAGE, IF ANY, TO AN INTERNAL BUFFER INSTEAD OF THE 
          USER DAYFILE. 
  
          AML    11/01/88    FATTACH, FGET
  
 TCH0016  FTP/NOS DOES NOT SUPPORT IP ADDRESS ON OPEN COMMAND.
  
          FTP/NOS DOES NOT ALLOW USERS TO SPECIFY AN INTERNET 
          NUMBER ON OPEN COMMAND. 
          CORRECTIVE CODE IS SUCH THAT FTP/NOS IS MODIFIED TO 
          SUPPORT IP ADDRESS ON OPEN COMMAND TO BE CONSISTENT 
          WITH FTP/VE AND OTHER VENDOR'S FTP. 
  
          AML            12/05/88       FFSLCIP,FFSUVIP 
  
 TCH0024  FTP ALLOWS ACCESS TO USER NUMBERS WITH USER INDICES GT 37770B.
  
          CORRECTIVE CODE IS SUCH THAT FTP SERVER WOULD DISALLOW ACCESS 
          TO THESE USER NUMBERS, WHILE IN CLIENT MODE, USERS FROM SYSTEM
          CONSOLE OR TERMINALS WHERE LOCAL MOD IS APPLIED ARE ALLOWED.
  
          AML            12/05/88       FFSUVUI 
  
 TCH0026  NOS FTP HANGS ON DIR COMMAND IF USING PC WITH 3COM 3C501 BOARD. 
  
          PROBLEM IS THAT WHEN THE FTP SERVER INITIATES THE DATA
          CONNECTION AND IT IS PRESENTED TO A 3COM BOARD, THE 3COM BOARD
          CAN NOT HANDLE THE CONNECTION REQUEST BEFORE IT HAS PROCESSED 
          AND ACK'ED THE PREVIOUS 150 MESSAGE.
  
          ADD A DELAY BEFORE THE DATA CONNECTION IS OPENED. 
          THIS CODE WILL ALEVIATE THE PROBLEM IN MOST CASES BUT 
          WILL NOT FIX THE PROBLEM IN ALL CASES.
  
  
          KPH            02/27/89       FFSLCRP,DELAYTM 
 *L739*    ************************************************ 
 TCHA055  NOS FTP DOES NOT GET ENOUGH OF THE CPU DURING ITS INITIAL 
          LINK UP PHASE.  THIS IS DUE TO THE FIXING OF PSR NS2G410
          THAT NOW PUTS FTP INTO ITS SERVICE CLASS WITH THE PROPER
          CPU PRIORITY. 
  
          SOLUTION: FTP WILL NOW START AT CPU PRIORITY 70B VIA THE
          SSJ BLOCK AND AFTER THE CONTROL CONNECTION IS COMPLETE, 
          FTP WILL RESET IT*S PRIORITY TO THAT OF THE "CT" SERVICE
          CLASS.
  
          KPH            FFSCIP, FTPS, CHNGCPU
 TCHA058  FTP ABORTED DUE TO AN ERR/LGL.
  
          FTP TRIED TO SEND A DATA BLOCK TO NAM THAT WAS TOO
          LARGE.  NAM SENT AN *ERR/LGL* MESSAGE TP FTP WHICH
          THEN ABORTED. 
          THE BLOCK SIZE ERROR WAS CAUSED BY
                 1) FTP READING THE FET POINTERS WHICH INDICATED
                    NO DATA 
                 2) THEN READING THE COMPLETE BIT OF THE FET
                    AND RECOGNIZING THAT AN EOF HAD BEEN READ.
          THE PROBLEM IS THAT BETWEEN STEP 1 AND STEP 2 THEN FET
          POINTERS WERE UPDATED AND THE FET COMPLETE BIT SET. 
          THIS CAUSED FTP TO ABNORMALLY DETERMINE THAT ALL THE
          DATA FOR THIS FILE WAS TRANSFERED ( NONE HAD BEEN 
          TRANSFERRED) AND USE THE BYTE COUNT FOR THE FILE
          (A 7 OCTAL DIGIT NUMBER) FOR THE AMOUNT OF DATA BEING 
          SENT IN THIS BLOCK. 
  
  
  
          THE SOLUTION IS TO HAVE FTP/NOS READ THE COMPLETE BIT 
          BEFORE CHECKING THE FET POINTERS.  ITS USE WILL BE
          AFTER IT HAS BEEN DETERMINED THAT THERE IS NOT ENOUGH 
          DATA IN THE FET FOR A MAXIMUM SIZE TRANSFER.
  
          KPH            06/15/89       FFSCFIO 
 *L750*    ************************************************ 
 TCH0061  PROBLEM  - WHEN THE NOS FTP SERVER IS GIVEN THE COMMAND "TYPE E"
                     (WHICH MEANS TRANSMIT THE FILE IN EBCDIC), IT RESPONDS 
                     WITH "502 COMMAND NOT IMPLEMENTED", THIS IS NOT THE
                     CORRECT RESPONSE.  THIS CAUSES SOME SYSTEMS (UNISYS
                     IN THIS CASE), TO BECOME CONFUSED AND FILE TRANSFERS 
                     ARE NOT POSSIBLE.
          SOLUTION - THE NOS FTP SERVER WAS BEEN CORRECTED TO RESPOND WITH
                     A NEW "504" MESSAGE WHEN ANY OF THE UNSUPPORTED
                     "TYPE" PARAMETERS ARE ENTERED. 
          JRL    12/05/89    TEXTFFS,FFSIIPV,FFSIBCT,FFSLFLH
 *L774*    ************************************************ 
 TCH0011  PROBLEM  - NOS FTP DOES NOT SUPPORT STANDARD 8/12 ASCII FILES 
                     WITH ZERO BYTE TERMINATION.  INSTEAD IT SUPPORTS 
                     8/12 ASCII FILE WITH CR/LF TERMINATION.
          SOLUTION - THE "ASCII8" CODE SET HAS BEEN CHANGED TO USE ZERO 
                     BYTE LINE TERMINATION.  A NEW "ASCII8E" CODE SET HA
                     BEEN ADDED TO PROVIDE 8/12 WITH CR/LF LINE TERMINAT
          JRL    05/25/90    TEXTFFS,FFSIBCT,FFSUPCP,FFSCFIO
 TCH0066  PROBLEM  - NOS FTP HAS A NUMBER OF ACCOUNTING PROBLEMS.  THE
                     SOLUTION WILL ITEMIZE THE VARIOUS THINGS WHICH ARE 
*CALL COPYRITE
          SOLUTION - THIS CODE IS BASED ON THE SUGGESTED CODE RECEIVED F
                     DAVE BEAUSANG (SITE MASC).  THE FOLLOWING PROBLEMS 
                     HAVE BEEN FIXED. 
                       1) THE *ABIC* MESSAGE IS ALWAYS ISSUED AFTER A PR
                          USER COMMAND, EVEN IF NO CHARGE IS REQUIRED.
                       2) THE DEFAULT CHARGE IS ISSUED WHEN THE CHARGE I
                          REQUIRED, AND THE DEFAULT CHARGE EXISTS.  THIS
                          IS DONE FOR BOTH THE PRIMARY AND SECONDARY USE
                       3) SRU ACCUMULATION IS DISABLED UNTIL THE PRIMARY
                          USER IS ESTABLISHED.  THIS WILL PREVENT THE EN
                          USER FROM BEING CHARGED FOR THE SOCKET LISTEN 
                          TIME. 
*CALL COPYRITE
                          PRIMARY USER, *ACUN* FOR SECONDARY USERS, *ABC
                          FOR THE INITIAL CHARGE, AND *ACCN* FOR ALL OTH
                          CHARGES.
                       5) SOME DAYFILE MESSAGES HAVE BEEN CHANGED FROM U
                          ONLY TO USER AND SYSTEM.
                       6) FTP NOW SUPPORTS SECONDARY USER COMMANDS.  SEC
                          USER COMMANDS ARE ONLY ALLOWED IF SECONDARY US
                          STATEMENTS ARE ENABLED.  THE USER MUST ALSO BE
                          VALIDATED TO SPECIFY ALTERNATE FAMILIES, IF AN
                          ALTERNATE FAMILY IS SPECIFIED.
                       7) FTP NOW SUPPORTS SECONDARY ACCT COMMANDS.  THE
                          MUST BE VALIDATED TO USE NON-DEFAULT CHARGES F
                          THIS TO BE AVAILABLE. 
                       8) FTP NOW SUPPORTS THE *SYST* COMMAND.
                       9) THE ERROR MESSAGE FROM *SETCHG* IS NOW ISSUED 
                          THE DAYFILE CORRECTLY.
                      10) THE CORRECT COMMON BLOCK IS NOW USED BY *CHNGC
                      11) THE ULP TIMEOUTS HAVE BEEN INCREASED TO MORE
                          REASONABLE VALUES.
  
          JRL    12/17/90    TEXTFFS, FTPS,    FFSIP,   FFSML,   FFSCHLP
                             FFSIIPV, FFSLFLH, FFSUSUV, FFSUVUC, FFSUVUI
                             CHNGCPU, DISSR,   GETCSP,  GETVP,   RENSR
 TCH0075  PROBLEM  - WHEN A FILE IS TRANSFERRED FROM *NOS* TO A REMOTE
                     SYSTEM IN *ASCII* MODE, AND THE FILE CONTAINS AN 
                     INVALID 6/12 CHARACTER SEQUENCE, *FTP* IS SOMETIMES
                     ABORTED BY *NAM*.
                     ONCE *FTP* HAS STARTED TRANSFERRING THE DATA TO
                     *NAM*, IT SENDS THE DATA BLOCKS WITH THE Q-BIT CLEAR 
                     AND THE M-BIT SET.  WHEN THE ERROR OCCURS, IT ATTEMPS
                     TO SEND A DISCONNECT REQUEST, WHICH HAS THE Q-BIT
                     SET, AND THE M-BIT CLEAR.  THIS IS ILLEGAL AND 
                     *NAM* ABORTS THE APPLICATION.
          SOLUTION - THE DISCONNECT CODE HAS BEEN CHANGED TO CHECK THE
                     STATE OF THE M-BIT FOR THE CONNECTIONS OUTPUT.  AN 
                     EMPTY DATA MESSAGE WITH THE M-BIT CLEARED WILL BE
                     SENT, IF NECESSARY, BEFORE SENDING THE DISCONNECT
                     REQUEST. 
          JRL    10/04/90    TEXTFFS,FFSOOBN,FFSLTIP
 TCH0114  PROBLEM  - THE NOS FTP SERVER FAILS TO INTEROPERATE WITH
                     UNICOS 6.1.
  
          ANALYSIS - THE NOS FTP SERVER DOES NOT SUPPORT THE FTP ALLO 
                     COMMAND. RFC 959 REQUIRES THAT THIS COMMAND BE 
                     ACCEPTED EVEN IF THE INFORMATION IT CONTAINS IS
                     IGNORED. 
  
          SOLUTION - SUPPORT FOR THE ALLO COMMAND IS ADDED TO THE NOS 
                     FTP SERVER. THE COMMAND IS NOW ACCEPTED IN 
                     ACCORDANCE WITH RFC 959. 
  
          JEE    03/20/92    TEXTFFS,FFSCHLP,FFSIBCT,FFSIIPV,FFSLFLH
  
 *L797*    ************************************************ 
 TCH0126  PROBLEM  - IF A CHARGE/PROJECT NUMBER ENTERED BY A FTP CLIENT 
                     CONTAINS AN ASTERISK, IT IS REJECTED BY THE FTP
                     SERVER.
  
          ANALYSIS - THE NOS FTP SERVER ONLY SUPPORTS ALPHANUMERICS IN
                     THE ACCT COMMAND PARAMETERS FOR CHARGE AND PROJECT.
  
          SOLUTION - SUPPORT FOR AN ASTERISK AS WELL AS ALPHANUMERICS HAS 
                     BEEN ADDED TO THE ACCT COMMAND PARAMETER PROCESSING. 
  
          GAH    08/19/92    TEXTFFS,FFSIBCT
  
 TCH*92   PROBLEM  - CONTROL DATA CORPORATION HAS CHANGED ITS NAME
                     TO CONTROL DATA SYSTEMS INC, SO ALL COPYRIGHT
                     INFORMATION MUST BE UPDATED. 
  
          SOLUTION - UPDATE COPYRIGHT INFORMATION.
  
          BAO    08/20/92    COPYRITE,FFSIBCT,FFSUSMS,FFSUSRM,
                             FFSCGCR,FFSCLST,FFSUPFU,CHNGCPU, 
                             DATEVAL,DELAYTM,DISSR,GETCHG,GETSST, 
                             RENSR, SETCHG, SETVAL,VALID,XSNM,
                             COPYRITB,FFSCTAB,FGET,GETJSN,TEXTFCS,
                             FCSAMSP,FCSBDFN,FCSBRAF,FCSCAPF, 
                             FCSCCAL,FCSCCBM,FCSCCDM,FCSCCEE, 
                             FCSCCFN,FCSCCHC,FCSCCIF,FCSCCOF, 
                             FCSCCPC,FCSCCRD,FCSCCTT,FCSCCVM, 
                             FCSCCWD,FCSCDAL,FCSCDCI,FCSCDCL, 
                             FCSCDED,FCSCDEF,FCSCDFN,FCSCDFO, 
                             FCSCDHC,FCSCDID,FCSCDLH,FCSCDRH, 
                             FCSCDWD,FCSCEWD,FCSCGEF,FCSCLOU, 
                             FCSCPES,FCSCQUI,FCSCREF,FCSCSFC, 
                             FCSEPES,FCSFFTS,FCSFLIS,FCSFRNS, 
                             FCSFSCS,FCSFUSS,FCSIICT,FCSIIMT, 
                             FCSIINI,FCSIIOP,FCSIIPV,FCSIIXF, 
                             FCSIPCS,FCSIPES,FCSIPPF,FCSMATS, 
                             FCSMDTS,FCSMRFL,FCSMRMT,FCSNODB, 
                             FCSNOSM,FCSNPSM,FCSNWDB,FCSNWFR, 
                             FCSNWFS,FCSNWNT,FCSNWSM,FCSOFTO, 
                             FCSOWOF,FCSRPUC,FCSRRFF,FCSRSPM, 
                             FCSUCRC,FCSUCRE,FCSUFAE,FCSUGUL, 
                             FCSUIMB,FCSUVFC,FCSUVFN,FCSXPES, 
                             FCSISRP,FINFO,FPSTAT,FEWQST,GETCN, 
                             NOPRMPT,FTP,FCS7700,TEXTFFS,FFSML, 
                             FFSBCNE,FFSCHLP,FFSCRFR,FFSCRTO, 
                             FFSDPDB,FFSEABT,FFSEEFS,FFSEESC, 
                             FFSIP,FFSIBCT,FFSICCC,FFSIIMB, 
                             FFSIIMT,FFSIINI,FFSIIPT,FFSIIPV, 
                             FFSIRHF,FFSITIH,FFSLCIP,FFSLCRP, 
                             FFSLCSH,FFSLFLH,FFSLNTH,FFSLTIP, 
                             FFSMATS,FFSMDTS,FFSMRFL,FFSMRMT, 
                             FFSOOBN,FFSOSMG,FFSRADT,FFSRCDT, 
                             FFSRPDT,FFSRPER,FFSRPNR,FFSRSDT, 
                             FFSRSNC,FFSSIAA,FFSSPCB,FFSSPCE, 
                             FFSSPCR,FFSSPFA,FFSSPFI,FFSSPFN, 
                             FFSSPSI,FFSSPSM,FFSSSNA,FFSTP, 
                             FFSTATE,FFSTCTE,FFSTCTE,FFSUCDA, 
                             FFSUCDC,FFSUCIA,FFSUCLR,FFSUDFN, 
                             FFSUFWE,FFSUISC,FFSULAP,FFSULEN, 
                             FFSULLN,FFSULOC,FFSULWC,FFSUMOD, 
                             FFSUPAR,FFSUPCP,FFSUPEF,FFSUPFC, 
                             FFSURAE,FFSURFF,FFSUSEM,FFSUSUV, 
                             FFSUTBZ,FFSUVFN,FFSUVUC,FFSUVUI, 
                             FFSUVUN,FFSUWIO,FFSUWTB,FFSXPES, 
                             FFSCFIO,FFSCGCR,FFSCLST,FFSFOLR, 
                             FFSISRP,FFSMRCM,FFSUPFU
  
  
 *L803*    ************************************************ 
 TCH0048  PROBLEM  - WHEN FTP IS RUN IN BATCH MODE, ALL OF THE COMMANDS 
                     IN THE PROLOG FILE ARE WRITTEN TO THE OUTPUT FILE. 
                     THESE COMMANDS FREQUENTLY INCLUDE PASSWORD VALUES, 
                     WHICH SHOULD NOT BE DISPLAYED.  THE DECISION TO
                     DISPLAY A COMMAND IS BASED ON WHETHER THE JOB
                     SOURCE IS INTERACTIVE OR BATCH.
          SOLUTION - FTP HAS BEEN MODIFIED TO SUPPRESS DISPLAY OF ALL 
                     COMMANDS IN THE PROLOG FILE.  DISPLAY OF OTHER 
                     SESSION COMMANDS IS STILL BASED ON THE JOB SOURCE. 
          JEE    09/01/93    FCSIPPF,FCSRRUC,FCSXPES
 TCH0049  PROBLEM  - FTP DISALLOWS ACCESS TO ANY IP ADDRESS THAT
                     CONTAINS A BYTE WITH A VALUE OF ZERO OR 255. 
                     THIS DISALLOWS MANY VALID IP ADDRESSES.
          SOLUTION - ADDRESS VALIDATION HAS BEEN CHANGED TO VERIFY
                     THAT THE NETWORK AND HOST PORTIONS OF THE IP 
                     ADDRESS DO NOT CONTAIN ALL ZEROS OR ALL ONES 
                     WHEN VIEWED AS BINARY NUMBERS. 
          JEE    09/30/93    FFSUCIA, FFSUVIP 
 TCH0081  PROBLEM  - FTP LOOPS IN A CPU INTENSIVE LOOP WHEN THE 
                     MDI IS UNAVAILABLE DURING STARTUP. 
          SOLUTION - A NETWAIT OF 30 SECONDS IS ADDED TO THE LOOP 
                     SO THE CONNECTION ATTEMPT IS NOT IMMEDIATELY 
                     RETRIED. 
  
          JEE        10/6/93          FFSSPCA 
 TCH0091  PROBLEM  - FTP CODE CONVERSION IS VERY INEFFICIENT. 
          SOLUTION - CODE TO ADDRESS THE PROBLEMS HAS BEEN
                     DEVELOPED BY REGION IV TO IMPROVE THE
                     CONVERSION ALGORITHMS. THE CHANGES ARE 
                     DESCRIBED AS FOLLOWS.
  
          ****   NOS 2.8.1-803/803/803 OS.
          ****   REGION IV FEATURE. 
          ****   IMPROVE FTP PERFORMANCE. 
  
          VERSION 1.0  - 92/12/05.
          AFTERBURN ROUTINES *GCH* AND *PCH* INTO MAIN ROUTINE. 
  
          VERSION 1.1  - 92/12/12.
          IMPROVE EOF CHECK IN *WCH*. 
  
          VERSION 1.2  - 93/02/21.
          REMOVE REFERENCE TO *ENDF* AFTER EACH CHARACTER.
  
          VERSION 1.3  - 93/03/08.
          REMOVE DIVIDE INSTRUCTION IN *WCH*. 
  
          VERSION 1.4  - 93/03/08.
          IMPROVE *EOL* CHECK.
  
          VERSION 1.5  - 93/03/14.
          AFTERBURN *WCH* INTO MAIN ROUTINE.
  
          VERSION 1.6  - 93/03/18.
          MAKE SEPARATE ROUTINES FOR FOR RETR AND STOR/APPE.
  
          VERSION 1.7  - 93/03/19.
          AFTERBURN *RCH* IN RETR ROUTINE.
  
          VERSION 1.8  - 93/03/20.
          GET RID OF *RAHD*.  AFTERBURN *RCH* IN STOR/APPE ROUTINE. 
  
          VERSION 1.9  - 93/03/26.
          REMOVE SUBSCRIPT CHECK ON XLATE TABLE, *INDX* RESTRUCTURE.
  
          VERSION 1.10 - 93/04/05.
          MOVE EOI CHECK. 
  
          VERSION 1.11 - 93/04/10.
          HARD-CODE SHIFT INSTRUCTIONS IN STOR/APPE.
  
          VERSION 1.12 - 93/04/17.
          MAKE SEPARATE ROUTINES FOR 6 BIT AND 12 BIT DISK INPUT. 
  
          VERSION 1.13 - 93/05/07.
          REMOVE COUNT FROM XLATE TABLE ON RETR.
  
          VERSION 1.13A - 93/10/12. 
          FIX STOR/APPE TO NOT TRASH OUTPUT WORD IF <CR> NOT FOLLOWED 
          BY <LF>.  THIS PROBLEM WAS PROBABLY INTRODUCED BY V1.9. 
          ALSO HANDLE CASE OF <CR><CR><LF> AS DOCUMENTED BY TCH0078.
          FIX *BLD* TO BUILD CONVERSION EXTENSION TABLE CORRECTLY 
          FOR DISPLAY CODE SET (<CR> HAS NO TRANSLATION). 
  
          JEE    10/19/93    FFSCFIO
 TCH0090  PROBLEM  - FTP DOES NOT BLANK OUT THE PASSWORD VALUE ENTERED
                     INTERACTIVELY BY THE USER. 
          SOLUTION - PROCESSING OF THE PASSWORD PROMPT AND THE USER'S 
                     RESPONSE IS MODIFIED TO OVERWRITE THE PASSWORD 
                     VALUE. 
  
          JEE    09/01/93    FCSFLIS,FCSROPM,FCSRSPM
 TCH0093  PROBLEM -  FTP GENERATES DAYFILE MESSAGES THAT START IN 
                     COLUMN ONE.  THIS DOES NOT CONFORM TO NOS
                     CONVENTIONS, AND INTERFERES WITH UTILITIES 
                     THAT PROCESS THE DAYFILE.
          SOLUTION - THE DAYFILE MESSAGES PRODUCED BY FTP ARE 
                     MODIFIED TO LEAVE COLUMN ONE BLANK.
          JEE    09/08/93   FCSAMSP,FCSCCHC,FCSEPES,FCSFFTS 
                            FCSFLIS,FCSFRNS,FCSFSCS,FCSFUSS 
                            FCSIINI,FCSIPCS,FCSISRP,FFSML 
                            FFSEEFS,FFSIP,FFSICCC,FFSIINI 
                            FFSIRHF,FFSITIH,FFSLCSH,FFSLFLH 
                            FFSLTIP,FFSMRFL,FFSRADT,FFSRCDT 
                            FFSRPDT,FFSRPER,FFSRPNR,FFSRSDT 
                            FFSSPCA,FFSSPCB,FFSSPSM,FFSUDFN 
                            FFSUPEF,FFSUPFC,FFSUSEM,FFSISRP 
 TCH0139  PROBLEM  - FTP LOOPS ENDLESSLY WHEN TRYING TO DO A
                     BINARY TRANSFER OF A FILE CONTAINING ONLY
                     AN EOF.
          SOLUTION - THE LOOP IS NOW TERMINATED WHEN BOI IS 
                     ENCOUNTERED WHILE SEARCHING FOR THE CONTROL
                     BLOCK. 
 *L826*    ************************************************ 
 TCH0070  PROBLEM  - THE SPECIAL REQUEST FIELD OF THE FET IS BEING
                     OVERWRITTEN BY THE CHANGE MACRO. 
          SOLUTION - THE SPECIAL REQUEST FIELD IS NOW SET ON THE
                     CHANGE MACRO CALL ITSELF.
          JEE    12/02/93    FFSUPFU
 TCH0103  PROBLEM  - FTP HANDLES INVALID 6/12 CHARACTERS POORLY.  THIS
                     PROBLEM IS PARTICULARLY NOTICEABLE WHEN TRANSFER-
                     RING DISPLAY CODE FILES, SINCE THE DEFAULT CODE
                     SET IS ASCII 6/12. 
  
          SOLUTION - FCOPY HANDLES THIS PROBLEM BY GENERATING A WARNING 
                     MESSAGE AND DISCARDING THE CHARACTER.  SINCE FTP 
                     DOES NOT PROVIDE A MECHANISM FOR DELIVERING
                     WARNINGS, THIS SOLUTION IS NOT WORKABLE FOR FTP. 
  
                     FTP DOES ALLOW A USER TO SPECIFY THE CODE SET FOR
                     EACH FILE TRANSFER WITH PARAMETERS INCLUDED IN THE 
                     FILE SPECIFICATION.  THE SYNTAX FOR THIS SPECIFI-
                     CATION IS UNIQUE TO NOS, THOUGH, AND IS NOT VERY 
                     OBVIOUS TO THE AVERAGE USER.  SEVERAL CHANGES HAVE 
                     BEEN MADE TO IMPROVE THE USABILITY OF THIS 
                     CAPABILITY:  
  
                     1) THE COMMAND INFORMATION FOR THE APPEND_FILE,
                     GET_FILE AND REPLACE_FILE COMMANDS IS EXPANDED TO
                     INCLUDE OPTIONAL PARAMETERS SUCH AS CODE_SET.
  
                     2) A NEW FTP CLIENT COMMAND, CHANGE_CODE_SET, CAN
                     BE USED TO CHANGE THE DEFAULT CODE SET.
  
                     3) THE FTP SERVER IS MODIFIED TO USE THE SITE
                     COMMAND TO CHANGE THE DEFAULT CODE SET AND FILE
                     TYPE (INDIRECT OR DIRECT ACCESS).  IN ORDER TO USE 
                     THIS CAPABILITY, A USER ON A TYPICAL UNIX WORK-
                     STATION WOULD ENTER A COMMAND LIKE THE FOLLOWING:  
  
                          QUOTE SITE CS=D IA
  
                     4) THE REMOTE HELP DISPLAYS ARE MODIFIED TO SHOW 
                     THE SYNTAX SUPPORTED ON THE SITE COMMAND.
  
                     5) THE DISPLAY_DIRECTORY AND DISPLAY_FILE_NAMES
                     COMMANDS ARE MODIFIED TO FORCE A DEFAULT CODE SET
                     VALUE OF ASCII FOR THE DISPLAY.
  
                     6) THE DISPLAY_FTP_OPTIONS COMMAND IS MODIFIED TO
                     DISPLAY THE CURRENTLY SELECTED DEFAULT CODE SET. 
  
          JEE    02/02/94    TEXTFCS,TEXTFFS,FCSBDFN,FCSCDCI,FCSCDFO, 
                             FCSCDLH,FCSCPES,FCSIICT,FCSIIPV,FFSCHLP, 
                             FFSIBCT,FFSIIPV,FFSLFLH,FFSUPCP,FFSUPFC, 
                             FCSCCCS
 TCH*94   PROBLEM -  COPYRIGHT STATEMENTS NEED TO BE UPDATED. 
  
          SOLUTION - UPDATE ALL COPYRIGHTS TO 1994 AND CHANGE ANY REFERENCES
                     TO CONTROL DATA CORPORATION TO CONTROL DATA SYSTEMS INC. 
  
          BAO    03/17/94    COPYRIGHT,COPYRITB,COPYRITE,FFSIBCT,FFSUSMS, 
                             FFSUSRM,FFSCGCR,FFSCLST,FFSUPFU,CHNGCPU, 
                             DATEVAL,DELAYTM,DISSR,GETCHG,GETCSP,GETSST,
                             GETVP,RENSR,SETCHG,SETVAL,VALID,XSNM,FFSCTAB 
 TCH0102  PROBLEM  - FTPS AND FTPI BOTH ABORT WITH UNRECOGNIZED CONTROL 
                     STATEMENT PARAMETER WHEN THE MDI CONNECTION IS LOST.  THIS 
                     PROBLEM WAS INTRODUCED BY THE CODE FOR TCH0066.
          SOLUTION - THE SUGGESTED CORRECTIVE CODE RESOLVES THE PROBLEM BY
                     DELETING OBSOLETE CODE THAT WAS INITIALIZING A RECORD THAT 
                     IS NO LONGER USED. 
          JEE    11/11/93    FFSIIPV
 TCH0107  PROBLEM  - TCH0066 REQUIRES THE DEFAULT FAMILY NAME TO BE 
                     ENTERED IF THE USER DOES NOT HAVE CSAF PERMISSION. 
          SOLUTION - THE CODE SUGGESTED IN THE PSR TEXT IS IMPLEMENTED. 
                     THE FAMILY NAME IS CHECKED FOR BINARY ZERO TO DETECT 
                     THIS SITUATION.
          JEE    11/30/93    FFSUVUI
 TCH0110  PROBLEM  - THE FTP COMMAND BUFFER IS NOT LARGE ENOUGH TO HOLD 
                     A MAXIMUM SIZE NETWORK BLOCK.  IF THIS BUFFER
                     OVERFLOWS DUE TO AN UNEXPECTEDLY LARGE COMMAND 
                     RESPONSE, A PORTION OF THE COMMAND TABLE IS OVER-
                     WRITTEN.  ALSO, FTPI IS CONSOLIDATING MULTIPLE 
                     RESPONSE BLOCKS INTO A SINGLE BLOCK UNTIL A BLOCK
                     TERMINATED WITH A CR LF SEQUENCE IS RECEIVED.
                     THIS CAN RESULT IN A BLOCK LARGER THAN THE BUFFER. 
          SOLUTION - THE COMMAND BUFFER IS ENLARGED TO ALLOW ROOM FOR 
                     A MAXIMUM SIZE NETWORK BLOCK.  THE MESSAGE CONSOLI-
                     DATION FUNCTION IS ALSO REMOVED FROM FTPI AND NOW
                     IS PERFORMED SOLELY IN THE CLIENT CODE.
          JEE    11/18/93    TEXTFFS,FCSNWFR,FFSIIPV,FFSITIH,FFSXPES
 TCH0111  PROBLEM  - WHEN *FTP* SESSIONS ABORT, AN ATTEMPT TO SAVE
                     THE *RUN DATA* UNDER USER *UNM* (USUALLY *NETOPS*) 
                     SOMETIMES STORES THE DATA UNDER THE WRONG *UNM*. 
                     THIS IS THE CASE WHEN THE *FTP* SESSION RUNS 
                     UNDER A *USER* THAT IS NOT ON THE *DEFAULT* FAMILY.
                     THE *COLLECT* UTILITY ONLY COPIES/PURGES DUMPS 
                     FROM *UNM* ON THE *DEFAULT* FAMILY.
          SOLUTION - CHANGE THE *FTP* SKELETON RECORDS IN *NAMSTRT* 
                     TO INCLUDE THE THIRD PARAMETER *0* ON THE *USER* 
                     COMMAND, THUS SWITCHING TO THE SYSTEM DEFAULT
                     FAMILY.  THIS IS THE SUGGESTED CODE SUBMITTED IN 
                     THE PSR. 
          JEE    11/30/93    JOBFTPI, JOBFTPS 
 TCH0136  PROBLEM  - IF A USER ENTERS BAD VALIDATION INFORMATION
                     FOLLOWED IMMEDIATELY BY A FILE TRANSFER COMMAND, 
                     A FILE IS CREATED UNDER USER INDEX 377777B.
          SOLUTION - THE CODE RECOMMENDED IN THE PSR TEXT HAS BEEN
                     USED TO RESOLVE THIS PROBLEM.  THE FTP STATE IS
                     CHECKED BEFORE A FILE IS CREATED.
          JEE    11/30/93    FFSLFLH
 TCH0140  PROBLEM  - FTP DOES NOT PLACE ANY DIAGNOSTIC INFORMATION
                     IN THE DAYFILE WHEN IT ABORTS. 
          SOLUTION - TERMINATION PROCESSING IS MODIFIED TO PLACE
                     THE MESSAGE DESCRIBING THE REASON FOR THE
                     ABNORMAL TERMINATION IN THE USER AND SYSTEM
                     DAYFILES.  ALSO, THE MESSAGE 'FTP ABORTED' 
                     WILL BE LOGGED INSTEAD OF 'FTP COMPLETE'.
          JEE    11/19/93    FCSEPES
 *L840*    ************************************************ 
 *L847*    ************************************************ 
TCH0146  PROBLEM -  MODSET TCH0093 INTRODUCED A SPACE CHARACTER 
                    BEFORE THE OPERATOR ACTION MESSAGE TO 
                    INDICATE HOST FILE NOT FOUND TYPE GO/DROP.
                    AS A RESULT, THE MESSAGE NO LONGER FLASHES. 
  
         SOLUTION - DELETE THE SPACE INTRODUCED BY TCH0093 IN 
                    FRONT OF THE HOST FILE NOT FOUND, GO/DROP.
         BAO     04/05/95   FFSIRHF 
 *L851*    ************************************************ 
 *L871*    ************************************************ 
 PSRLEVEL - CHANGE PSR LEVEL AND VERSION
  
          NBF            08/16/88       COMPSRL 
 TTNA032  *NAMSTRT* RECORDS FOR FTP/NOS FULL RELEASE. 
  
          THIS MODSET PROVIDES THE *NAMSTRT* STARTUP RECORDS FOR
          THE FTP/NOS APPLICATIONS. 
  
          RWH            04/11/88       JOBFTPI, JOBFTIR, JOBFTPS,
                                        JOBFTSR.
  
 TTNA027 PROBLEM  - FTPI SHOULD DAYFILE JSN OF FTP IN ALL DAYFILES. 
         SOLUTION - FTPI HAS BEEN CHANGED TO DO THAT. 
         TET    03/11/87    FFSLCSH 
  
 TTNA030  FTP SHOULD IGNORE FTP REPLIES PRIOR TO DISCONNECT 
  
          FTP CONTROL STATEMENT IS MODIFIED TO IGNORE ANY FTP 
          REPLIES RECEIVED WHILE IT IS WAITING FOR A REMOTE 
          DISCONNECT INDICATION.
  
          THIS MODSET ALSO FIXES MISSING DECKS ON PL. 
  
          CJR            88/04/11       FCSNWDB 
  
  
 TTNA021 PROBLEM  - "LIST, LO=F" GENERATES FILE NOT FOUND MESSAGE.
                    ALSO, NOS PERMENANT FILE ERROR MESSAGES ARE NOT 
                    ZEROBYTE TERMINATED.
         SOLUTION - THE PROBLEMS ARE FIXED. 
  
         TET    04/11/87    FFSLFLH, FFSUVUC, FFSUPFC 
  
 TTNA020  THE ULP TIMEOUT ON THE CONTROL CONNECTION WAS SET TO 777 SECS.
          IT HAS BEEN LOWERED TO 120 SECONDS. 
  
          CMP 04/88  FFSIP. 
  
 TTNA024  FTPS/FTPI WAS ABORTING WITH NPE CON/REQ/R RECEIVED. THE 
          PROBLEM WAS CAUSED BY A FAILED CONNECTION ATTEMPTS BEING
          REATTEMPTED WITH THE WRONG CONNECTION TYPE SET IN THE 
          CON/REQ.
  
          CMP 04/88  FFSIIAA,FFSSPCB
  
 TTNA033  FTPS ABORTS WITH
          "FFSLCSH - STTB HANDLER ABORTS, STATE = 10, TRIG = 14"
  
          PROBLEM:  
          CURRENT CONNECTION MANAGEMENT STATE TABLE ABORTS
          ON CONTROL CONNECTION A-A BROKEN IN STATE 10
          WHICH IS SAP CONNECTION COMPLETED, CONTROL PASSIVE
          CONNECTION INCOMPLETE, AND DATA CONNECTION NOT
          CONNECTED.
  
          SOLUTION: 
          CORRECTIVE CODE IS TO ISSUE A CONTROL PASSIVE CONNECT 
          REQUEST UPON THE AFORE-MENTIONED SITUATION. 
  
  
          AML            04/12/88       FFSLCSH 
  
 TTNA022 PROBLEM  - FTPI SENT CONFUSING 421 MESSAGE TO CONTROL
                    STATEMENT.
         SOLUTION - THE 421 MESSAGE TEXT IS CHANGED TO A MORE 
                    GENERIC ONE "CONTROL CONNECTION TERMINATED" 
                    INSTEAD OF "SERVICE NOT AVAILABLE". 
         TET    04/12/88    FFSLCSH.
  
 TTNA025  FTPS ABORTED WITH "FFSLFLH - STATE OUT OF RANGE." 
  
          PROBLEM:  
          1) INTERNAL BUFFER USED BY FFSLFLH FOR DATA CONVERSION
             IS TOO SMALL, WHICH RESULTS IN CLOBBERING OF MEMORY
             WHEN THE DATA TO BE CONVERTED IS BIGGER THAN THE 
             BUFFER CAN ACCOMMODATE.
  
          2) UPON EXIT FROM FFSUSEM, THE MORE$T IS LEFT SET,
             WHICH RESULTS IN A SECOND ERRONEOUS CALL TO SEND 
             GARBAGE OVER THE CONTROL CONNECTION. 
  
  
          SOLUTION: 
          1) CHANGE THE SIZE OF THE BUFFER TO THE MAXIMUM SIZE
             OF A NIP BLOCK.
  
          2) CLEAR MORE$T BEFORE EXITING FROM FFSUSEM.
  
  
          AML            04/12/88       FFSLFLH,FFSUSEM 
  
 TTNA026  FTPI ABORTED WITH AN INTERNAL ERROR.
  
          PROBLEM:  
          WHEN FTPI GETS A CON/CB ON THE CONTROL CONNECTION,
          IT CALLS A NETOFF PROCESSOR TO DISCONNECT ITSELF
          FROM THE NETWORK.  THERE IS TRAP CODE IN THE
          NETOFF PROCESSOR TO ABORT WITH AN INTERNAL ERROR
          DAYFILE MESSAGE IF THERE IS AN ACTIVE CONTROL 
          STATEMENT CONNECTED TO IT.  REASON FOR THE TRAP 
          WAS TO BE ABLE TO COLLECT TRACE AND DUMP FOR FTPI.
  
          SOLUTION: 
          REMOVE THE TRAP CODE FROM THE NETOFF PROCESSOR. 
          ADD CODE TO THE CON/CB PROCESSOR TO DAYFILE A 
          MESSAGE UPON PROCESSING OF A CON/CB SM. 
  
          AML            04/12/88       FFSUDFN,FFSSPCB 
  
 TTNA023  FTPI/FTPS SHOULD BYPASS SPAWN AND NETOFF IN 
          REPRIEVE PROCESSING IF NOT NETTED ON. 
  
          PROBLEM:  
          CURRENTLY IN REPRIEVE PROCESSING, FTPI/FTPS 
          ALWAYS SPAWN ITSELF AND NETOFF REGARDLESS 
          IF IT HAS NETTED ON.
  
          SOLUTION: 
          REPRIEVE PROCESSING IS MODIFIED TO BY PASS
          SPAWN AND NETOFF IF THE APPLICATION HAS NOT 
          NETTED ON.
  
          AML            04/14/88       FFSISRP,FFSML 
  
 TTNA038  FTP HANGS ON CLOSE COMMAND WHEN NO REMOTE HOST CONNECTION 
  
          FTP IS MODIFIED TO ONLY WAIT FOR A DISCONNECT INDICATION
          IF THE FTP *QUIT* COMMAND IS SENT AND A *221* OR *421*
          REPLY IS RECEIVED FROM THE REMOTE HOST. 
  
          THIS PSR ALSO IMPROVES THE BLOCK PROTOCOL VALIDATION OF FTP.
  
          CJR            88/04/14       FCSCCHC, FCSCDHC, FCSIINI,
                                        FCSNWDB, FCSNWFR
  
 TTNA039  PROBLEM:  
          FC RELEASE INDICATIONS FROM THE NAM LAYER CAN CAUSE A TCP 
          STATE TABLE ABORT IF THEY ARE SENT AFTER THE TCP LAYER HAS
          ABORTED THE TCP CONNECTION. THE SAME APPLIES TO NO-OUTSTANDING
          -DATA INDICATIONS.
  
          SOLUTION: 
          THE TCP STATE TABLES HAVE BEEN ALTERED TO IGNORE FCREL AND
          NOOD INDICATIONS RECEIVED IN THE CLOSING/ABORTING STATES. 
          ALSO THE FTP LAYER HANDLER HAS BEEN ALTERED TO SWITCH OFF 
          THE GENERATION OF NOOD INDICATIONS WHENEVER THE DATA CN IS
          ABORTED (SOLICITED OR UNSOLICITED). 
  
          CMP 04/88 FFSLFLH,FFSLTIP 
  
 TTNA044  PROBLEM:  
          LARGE FILE RECEIVES WERE HANGING DUE TO THE ALLOCATION
          GOING NEGATIVE IN THE GDI. THE TCPAC WAS SETTING *FFFF* 
          AND THE TCPA THEREAFTER WAS ADDING *FFFFFFFF*.
  
          SOLUTION: 
          THIS SOLUTION IS TEMPORARY UNTIL THE G/W IS FIXED TO IGNORE 
          ALL ALLOCATION AND DO IT FOR US. THE TCPAC WILL ALLOCATE
          *7FFF* AND THE TCPA WILL ALLOCATE *7FF30000*. THE NET RESULT
          WILL BE AN ALLOCATION LESS THAN *7FFFFFFF* WHICH WILL WORK
          FINE FOR FILES LESS THAN 8 BILLION BYTES. 
  
          CMP FFSITIH,FFSLTIP,FFSRPER 
  
 TTNA037  FTPI ABORTED WITH 
          "FFSLCSH - STTB HANDLER ABORTS, STATE = 6, TRIG = 36" 
  
          PROBLEM:  
          THERE IS A BUG IN CONNECTION MANAGEMENT STATE TABLE TO
          ABORT ON A TRIGGER OF 36 ( DATA CONNECTION ABORTED) 
          IN STATE 6 ( CLIENT FILE SERVER AND CONTROL STATEMENT 
          LIASION ESTABLISHED). 
  
          SOLUTION: 
          BOTH THE CONNECTION MANAGEMENT STATE TABLE AND FTPI 
          IS MODIFIED TO PROCESS THIS AS A LEGITIMATE TRIGGER 
          IN STATE 6, AND PASS A CONNECTION ABORTED INDICATION
          TO THE FTP LAYER. 
  
          AML            04/15/88       FFSLCSH 
  
 TTNA043  FTPS SENDS ERRONEOUS 503 BAD SEQUENCE OF COMMAND. 
  
          PROBLEM:  
          ON SECOND OR SUBSEQUENT RENAME COMMAND, FTPS
          SENDS AN ERRONEOUS 503 BAD SEQUENCE OF COMMAND
          UPON PROCESSING OF A RNFR PROTOCOL ELEMENT. 
          THIS IS CAUSED BY INTERNAL GLOBAL ELEMENTS WHICH
          ARE USED TO INDICATE THE RNFR AND RNTO SEQUENCE 
          NOT RESET PROPERLY AT THE END OF THE SEQUENCE.
  
          SOLUTION: 
          FTPS IS MODIFIED TO CLEAR THESE TWO GLOBAL ELEMENTS 
          AT THE END OF THE RNFR, RNTO SEQUENCE.
  
          AML            04/18/88       FFSLFLH 
  
 TTNA041  FTPI ABORTED WITH 
          "FFSLCSH - STTB HANDLER ABORTS, STATE=0, TRIG =8" 
  
          THIS IS CAUSED BY AN ERROR IN THE CONNECTION MANAGEMENT 
          STATE TABLE CODING. 
  
          FTPI IS MODIFIED TO CONFORM TO THE STATE TABLE. 
  
          AML            04/18/88       FFSLCSH 
  
 TTNA028 PROBLEM  - FTPS ABORT WITH CPU ERROR EXIT WHEN PROCESS 
                    THE ACCOUNT COMMAND.
         ANALYSIS - 1. THE INTERFACE TO THE *CHG* ROUTINE IN *OPL*
                       REQUIRES THAT THE CALLING PROGRAM HAS AN 
                       SSJ= PARAMETER BLOCK WHICH FTPS DID NOT HAVE.
                    2. THE CODE IN OPL DECK *COMCCHG*, WHICH WAS CALLED 
                       BY SETCHG, SETS UP SOME BUFFERS AT THE END BY IN-
                       CREASING THE LOCATION COUNTER INSTEAD OF ACTUALLY
                       ALLOCATING MEMORY.  THEREFORE IF *COMCCHG* IS NOT
                       AT THE END OF A PROGRAM, WHATEVER CODE FOLLOWED
                       *COMCCHG* WILL BE OVERLAYED WITH THOSE BUFFERS, AND
                       THE CODE WILL BE OVER WRITTEN WHEN A READ INTO 
                       THOSE BUFFERS IS DONE. 
         SOLUTION - 1. CREATE THE SSJ= PARAMETER BLOCK. 
                    2. AT THE BEGINNING OF THE CODE FOLLED *COMCCHG*, 
                       RESET THE LOCATION COUNTER BACK TO THE LAST LOCATION 
                       OF *COMCCHG*.
         TET    04/18/88    FTPS, SETCHG. 
  
 TTNA048  QUOTE COMMAND FAILS WITH PARAMETERS GREATER THAN 7 CHARACTERS 
  
          FTP IS MODIFIED TO PASS THE ADDRESS OF THE CORRECT PARAMETER
          BLOCK WHEN PROCESSING A QUOTE COMMAND.
  
          CJR            88/04/18       FCSFUSS 
  
 TTNA029  FTPS SHOULD ISSUE A 530 INSTEAD OF 503 MESSAGE BEFORE LOGIN.
  
          BOTH THE FTP STATE TABLE, AND THE FTP LAYER IS MODIFIED 
          TO REFLECT THIS CHANGE. 
  
          NOTE THAT THIS MODSET ALSO INCLUDE CODE FOR TTNA031.
  
          AML            04/26/88       TEXTFFS,FFSCHLP,FFSLFLH,
                                        FFSRADT,FFSRCDT,FFSRPDT,
                                        FFSRSDT,FFSUPCP,FFSUSRM.
 TTNA052  FTPI/FTPS ABORTS WITH INCORRECT ERROR FLAG
  
          IF FPTI/FTPS WAS ABORTED PRIOR TO NETTING ON IT WOULD 
          CALL NETOFF CAUSING A SUBSYSTEM ABORT TO OCCUR. THE 
          SOLUTION IS TO CHECK FOR NETON PRIOR TO CALLING NETOFF. 
          THIS PSR ALSO REMOVES THE FLUSHING OF THE STATISTICS
          AND TRACE FILE FROM REPRIEVE PROCESSING.
  
          CMP            88/04/21       FFSISRP 
  
 TTNA055 PROBLEM  - BESIDE TTNA021, SOME CODE IN ROUTINE FFSUPCP
                    IS NEEDED FOR IMPLEMENTING "LIST,LO=F" AND
                    "LIST,LO=0".
         SOLUTION - THE NEEDED CODE IS ADDED TO THE ROUTINE.
         TET    04/22/88    FFSUPCP.
  
 TTNA054 PROBLEM  - FTPI ABORTS WITH FOLLOWING MESSAGE, 
                       FFSLTIP - STTB HANDLER ABORTS, STATE =13,
                                 TRIG = 2.
         SOLUTION - THE TCP STATE TABLE IS UPDATED TO ALLOW TRIGGER 
                    2 IN STATE 13.  THE ACTION IS NOOP, NEXT STATE IS 
                    THE SAME. 
         TET    04/22/88     FFSLTIP. 
  
 TTNA050 PROBLEM  - SERVER ABORTED WHEN THE USER TRY THE
                    "USER" COMMAND THE SECOND TIME, AFTER 
                    THE UNSUCESSFUL FIRST ATTEMP. 
         SOLUTION - THIS HAPPENED DUE TO SOME ERROR IN THE
                    DESIGN AND CODING OF THE FTP STATE TABLE. 
                    THE NECESSARY CHANGES HAVE BEEN MADE TO 
                    THE TABLE TO FIX THIS.
         TET    04/26/88    FFSLFLH 
  
 TTNA035  FTPI/FTPS SHOULD SET THE PUSH FLAG IN TCPAC OR TCPPC
          INSTEAD OF TCPSD. 
  
          FTPS/FTPI IS MODIFIED TO SET THE PUSH FLAG IN TCPAC 
          OR TCPPC ON THE CONTROL CONNECTION. 
  
          AML            04/28/88       TEXTFFS,FFSIP,FFSLTIP.
  
 TTNA066 PROBLEM  - LO IS NO LONGER A SUPPORTED PARAMETER ON
                    LIST AND NLST COMMAND.
                    FTPS SHOULD ACCEPT ALL THREE, COMMA, BLANK, 
                    AND SLASH AS VALID SEPARATOR. 
         SOLUTION - CODE HAS BEEN GENERATED TO MAKE THE CHANGES 
                    MENTION ABOVE.
         TET    04/28/88     FFSIBCT, FFSUPFC, FFSUPCP
  
 TTNA070 PROBLEM  - FTPS ABORTED WITH CPU ERROR EXIT WHEN 
                    IT TRIED TO PROCESS 
                       "LIST,PN=PPPPPPPPPPPPPPPPPPPPPPPP.." 
         SOLUTION - FTPS ABORTED IN THE PARSER.  WHEN THE 
                    PARSER ASSEMBLYING TOKEN, IT DID NOT
                    CHECK FOR THE INPUT TOKEN LENGTH. IN
                    THIS CASE, THE VALUE FOR PN IS LONGER THAN
                    FOR A TOKEN CAN HOLD, AND THEREFORE, SOME 
                    MEMORY FOLLOWING TOKEN HAS BEEN OVERWRITTEN.
         TET    04/29/88    FFSUPFC 
  
 TTNA036  FTPI ABORTED WITH AN INTERNAL ERROR.
  
          FTPI/FTPS IS MODIFIED TO GENERATE A MORE
          SPECIFIC ERROR MESSAGE WHEN AN INTERNAL 
          INCONSISTENCY IS DETECTED BY THE APPLICATION. 
  
          AML            05/02/88       FFSEEFS,FFSLNTH,FFSOOBN,
                                        FFSSIAA.
  
 TTNA058  PROBLEM:  
          THE LIST/NLST REQUEST ON A SPECIFIC FILE GAVE ALL FILES.
          SOLUTION: 
          CODE HAS BEEN CORRECTED TO PUT THE FILENAME IN THE PFN FIELD
          IN THE FET. 
  
          CMP 05/88  FFSRSDT,FFSUPCP
  
 TTNA057 PROBLEM  - SERVER ABORTED IF SECOND USER COMMAND IS
                    SENT. 
         SOLUTION - THIS WAS DUE TO AN ERROR IN THE FTP LAYER 
                    STATE TABLE.  THE TABLE HAS BEEN CORRECTED. 
         TET    05/02/88     TEXTFFS, FFSLFLH 
  
 TTNA059  BINARY (AND OTHERS TOO) TRANSFERS WERE CORRUPTING THE FILE. 
          THE PROBLEM TURNED OUT TO BE THE TCP LAYER TRYING TO CLEAR
          THE URGENT BIT ON A DATA BLOCK WHICH DID NOT HAVE A HEADER. 
  
          CMP 05/88 FFSLTIP 
  
 TTNA071  APPE FILE,UN=ALTUSER SAVES FILE ON USER YOU ARE 
          LOGGED IN TO. 
  
          FTPI/FTPS IS MODIFIED TO CONFIRM TO THE FTP 
          PATHNAME MATRIX AS DOCUMENTED IN THE ERS. 
          THIS PSR SHOULD ALSO RESOLVE PSR TTNA067. 
  
          AML            05/03/88       TEXTFFS,FFSUPCP,FFSCHLP,
                                        FFSLFLH,FFSRADT,FFSRCDT,
                                        FFSRPDT,FFSRSDT,FFSUPFU,
                                        FFSUSEM,FFSUSRM.
 TTNA074  FTP NEEDS TO SUPPORT / AS A PATHNAME PARAMETER SEPARATOR
  
          FTP CONTROL STATEMENT IS MODIFIED TO ACCEPT A SLASH AS
          WELL AS A COMMA AS A PATHNAME PARAMETER SEPARATOR.
  
          CJR            88/05/04       TEXTFCS, FCSUVFN
  
 TTNA076 PROBLEM  - ACCORDING TO FTP STATE TABLE, WHEN A USER 
                    ENTER INVALID VALUES FOR ACCOUNT COMMAND, 
                    THE ACTION IS $BADR, WHICH ISSUE A 500 SYNTAX 
                    ERROR... THIS IS INCORRECT.  THE CORRECT REPONSE
                    IS 530 NOT LOGIN. 
         SOLUTION - DEFINE A NEW ACTION BACC, WHICH WILL ISSUE A
                    MULTILINE 530 RESPONSE, UPON RECEIVING AN IN- 
                    VALID ACCOUNT COMMAND.
  
         TET     05/04/88     TEXTFFS, FFSLFLH, FFSUSMS, FFSUVUC
  
 TTNA062  FTP COULD NOT BE RUN FROM ANY UI GREATER THAN *AUIMX*.
          THE PROBLEM HAS 2 PARTS:- 
          1. THE LOCAL-USER BLOCK FROM FTP TO FTPI HAS A UN SPECIFIED.
             IN THIS CASE, THE PROBLEM IS FIXED BY SETTING A BIT IN THE 
             PARAMETER BLOCK PASSED TO CPM WHICH TELLS CPM TO VALIDATE
             USERS WHOSE UI IS .GR. *AUIMX*.
          2. THE LOCAL-USER BLOCK FROM FTP DOES NOT HAVE A UN SPECIFIED.
             THEN THE CURE IS ONLY PARTIAL. FTPI CAN ONLY ISSUE A SET-
             USER-INDEX CPM FUNCTION. IT IS NOT POSSIBLE TO ISSUE A CPM 
             USER VALIDATION GIVING UI ONLY.
          CODE HAS BEEN GENERATED TO DO THE ABOVE.
  
          CMP 05/88 FFSLFLH,FFSUSUV,FFSUVUI,SETVAL. 
  
 TTNA072  FTPI/FTPS IS CHANGED TO USE VERSION NUMBER 10(16).
  
          CMP 05/88 FFSITIH,TEXTFFS 
  
 TTNA056  CHANGES TO *FTPI* AND *FTPS* STARTUP RECORDS. 
  
          CHANGES ARE REQUIRED TO THE *FTPI* AND *FTPS* STARTUP 
          RECORDS TO CONFORM TO THOSE OF OTHER HOST APPLICATIONS. 
  
          THE COMMENTS IN JOBFTPI AND JOBFTPS HAVE BEEN CHANGED 
          PER THE PSR-S REQUIREMENT.  ALSO THE *START* PARAMETERS 
          HAVE BEEN CHANGED AS REQUIRED.  NOTE THAT THE PARAMETERS
          ARE *PISTART* AND *TSSTART*, NOT *TSSTART* AND *FSSTART*. 
          ALSO NOTE THAT BUILD DECK CHANGES WILL BE REQUIRED TO 
          ACCOMODATE THE PARAMETER CHANGES. 
  
          RWH            5/10/88        JOBFTPI, JOBFTIR, JOBFTPS,
                                        JOBFTSR 
  
 TTNA079  FTP HANGS IF REMOTE FTP FAILS DURING FILE TRANSFER
  
          FTP WAS HUNG BECAUSE THE FTP STATE WAS UPDATED TO THE 
          IDLE STATE. THE SOLUTION IS TO NOT UPDATE THE FTP STATE 
          UNTIL FILE TRANSFER PROCESSING IS COMPLETE. 
  
          CJR            88/05/10       TEXTFCS, FCSFFTS, FCSNWFR 
  
 TTNA075 PROBLEMS - THIS MOD FIXES THE FOLLOWING SYNTAX PROBLEMS
                    1. THE STOR COMMAND SHOULD ALLOW UN PARAMETER.
                    2. DN PARAMETER SHOULD BE RESTRICTED TO 2 DIGITS. 
                    3. BLANKS SHOULD NO LONGER BE A VALID PATHNAME
                       SEPARATOR. 
                    4. CE WAS MISPELLED IN TEXTFFS. 
                    5. XT SHOULD ACCEPT * AS A VALID VALUE. 
                    6. LIST AND NLST SHOULD ACCEPT DN PARAMETER.
         SOLUTION - CHANGES ARE MADE TO CORRECT THE PROBLEMS MENTIONED. 
  
         TET    05/05/88     TEXTFFS, FFSIBCT, FFSUPFC
  
 TTNA083  FTP DOES NOT ALWAYS DEFAULT TRANSFER TYPE TO ASCII
  
          IF THE TRANSFER TYPE IS SET TO IMAGE AND THEN THE REMOTE
          CONNECTION IS CLOSED, WHEN A NEW REMOTE CONNECTION IS 
          ESTABLISHED, THE TRANSFER TYPE IS STILL SET TO IMAGE
          RATHER THAN THE DEFAULT OF ASCII. 
  
          CJR            88/05/12       FCSCCHC 
  
 TTNA081  ALTER VARIOUS STATE TABLES TO FIX PROBLEMS CAUSED BY THE
          CONTROL CONNECTION ON THE CLIENT BEING ABORTED. 
  
          CMP 05/88 FFSLCSH,FFSLFLH,FFSLTIP 
  
 TTNA077 PROBLEM  - FTPI/FTPS SHOULD DAYFILE THE REASON CODE
                    WHEN IT RECEIVES A CON/ACRQ.
         SOLUTION - EVERY TIME FTPI/FTPS RECEIVES A CON/ACRQ, 
                    IT WILL DAYFILE THE REASON CODE IF IT 
                    DIFFERS FROM THE PREVIOUSLY SAVED ONE. ALSO 
                    A "FTPI/FTPS INITIALIZED." DAYFILE MESSAGE
                    WILL BE ISSUE BY THE CONNECTION MANAGEMENT
                    LAYER WHEN ALL CON/ACRQS HAVE SUCCEEDED.
  
         TET     05/12/88    TEXTFFS, FFSIIPV, FFSSPCA, FFSLCSH.
  
 TTNA085  HELP RESPONSE ON NOS PATHNAME NEEDS TO BE MORE ELABORATE. 
  
          THE HELP RESPONSE ON PROTOCOL ELEMENTS SUCH AS APPE, STOR,
          RNFR, RNTO, LIST, NLST, DELE AND RETR IS MODIFIED SUCH THAT 
          WHERE IT USED TO SAY <PATHNAME> IS NOW SPELLING OUT THE NOS 
          PARAMETERS ALONG WITH THE DATA HANDLING PARAMETERS WHERE- 
          EVER IS APPROPRIATE.  IT CONFORMS TO THE PATHNAME MATRIX
          DOCUMENTED IN THE FTP/NOS ERS.
  
          AML            05/17/88       FFSCHLP 
  
 TTNA087  AN ASCII FILE DID NOT COMPARE AFTER TRANSFERRING IT TO THE VAX
          AND BACK. THE PROBLEM WAS CAUSED BY A <CR><LF> ON OUTPUT WHICH
          WAS SPLIT ACROSS A BLOCK BOUNDARY. THE BYTE COUNT ON BOTH 
          BLOCKS WAS OUT BY 1. THE CODE HAS BEEN ALTERED TO BUMP THE
          BYTE COUNT CORRECTLY. 
  
          CMP 05/88  FFSCFIO. 
  
 TTNA069  FTP HANGS WHEN TRYING TO CONNECT TO FTPI. 
  
          PROBLEM:  
          THIS HAPPENS WHEN FTP TRYS TO ESTABLISH AN A-A
          CONNECTION TO FTPI, AND THE FTPI HAS JUST FINISHED
          A SESSION WITH A FTP, I.E. IT HAS RECEIVED A CON/CB 
          FOR THE FTP CONNECTION AND HAS SENT A CON/END,
          AND PROCESSED A CON/END/N.  AT THIS POINT OF
          TIME, NIP THINKS THE CONNECTION IS FREE, AND
          ASSIGNS FTP TO THIS FTPI.  THE CON/REQ IS QUEUED
          FOR FTPI, BUT THE NEXT SEQUENCE OF EVENT FOR
          FTPI IS TO NET OFF, AND THIS LEAVES FTP HANGING.
  
          SOLUTION: 
          THIS IS AN END CASE IN FTPI NAM LAYER.
          CORRECTIVE CODE IS TO NOT SEND A CON/END
          IN RESPONSE TO A CON/CB ON INBOUND CONNECTION.
          SO NIP WILL NEVER ASSIGN THIS CONNECTION TO FTP.
          AND EVENTUALLY, THIS FTPI WILL NET OFF. 
  
          AML            05/19/88       FFSSPCB,FFSSPCE 
  
 TTNA088  CERTAIN SITE VARIABLES WERE NOT BEING INITIALISED BEFORE EACH 
          DATA TRANSFER COMMAND WAS EXECUTED. THIS RESULTED IN
          PREVIOUSLY SET VALUES BEING USED AGAIN EVEN THOUGH THEY WERE
          NOT SPECIFIED EG SITECS, SITERDEOI ETC. CODE IS ADDED TO
          CORRECTLY INITIALISE THESE. 
  
          CMP 05/88  FFSUPCP. 
  
 TTNA099  FTPI ABORTED IN CN MANAGEMENT STATE 6 TRIGGER 12. STATE TABLES
          HAVE BEEN AMENDED TO IGNORE DATA FROM C/S IN THE ABOVE STATE. 
  
          CMP 05/88  FFSLCSH. 
  
 TTNA095  FTPS ABORTED "FFSLTIP - STATE 0 TRIGGER 16".
  
          IN RESPONSE TO THE PASV PROTOCOL ELEMENT, FTPS
          SENT 227 TO THE WRONG CONNECTION WHICH CAUSE
          IT TO ABORT.
          CORRECTIVE CODE SHOULD SOLVE THE PROBLEM. 
  
          AML            05/26/88       FFSLFLH 
  
 TTNA100  FTPS WAS ABORTING DUE TO AN FC/ACK CAUSING A FC RELEASE IN AN 
          UNEXPECTED STATE. THE TCP STATE TABLES HAVE BEEN AMENDED TO 
          IGNORE THIS NOW.
  
          CMP 05/88  FFSLTIP
  
 TTNA110 PROBLEM  - AFTER THE SERVER RECEIVES A USER NAME, THE
                    FTP STATE TABLE IS IN A STATE WHICH IT ACCEPTS
                    A USER, AFTER MAKING A TYPE IN THE PASSWORD AND 
                                           MISTAKE IN THE PASSORD 
                    AND BEING REJECTED LOGGING IN, HAVE A TENDENCY
                    TO REENTER THE WHOLE USER COMMAND , INSTEAD OF
                    SHOULD BE CHANGED TO ACCEPT BOTH USER AND PASS
  
                    COMMANDS USER THIS SITUATION. 
         SOLUTION - CHANGES HAVE BEEN MADE TO THE FTP STATE TABLE 
                    TO SUPPORT BOTH COMMAND IN THE SITUATION ABOVE. 
  
         TET    06/01/88    FFSLFLH 
  
 TTNA109  FTPS WAS NOT DECREMENTING THE SECURITY COUNT ON FAILED LOGIN
          ATTEMPTS. 
  
          CMP  05/88  FFSUVUI,SETVAL. 
  
 TTNA098  FTPS SHOULD SUPPORT THE FIRST 3 CHARACTERS OF SS. 
  
          FTPS IS MODIFIED TO ALSO SUPPORT THE FIRST 3 CHARACTERS 
          OF THE SUBSYSTEM PARAMETER VALUE. 
  
          AML            06/01/88       TEXTFFS,FFSIBCT,FFSUPCP 
 TTNA101  UNIX VERSIONS OF FTP SOMETIMES DO NOT HANDLE A RESET ON THE 
          DATA CONNECTION PROPERLY. IF AN LS IS DONE ON A NON-EXISTING
          FILE, THE CURRENT FTP CODE WILL OPEN THE DATA CONNECTION AND
          ISSUE THE CATLIST FUNCTION WHICH WILL RETURN AN ERROR DUE TO
          THE FILE NOT FOUND. THE FTP LAYER THEN SENDS A 55O MESSAGE
          AND ABORTS THE DATA CONNECTION. SOMETIMES THIS CAUSES THE VAX 
          TO HANG.
          THE FTP LAYER HAS BEEN KLUDGED TO CLOSE THE DATA CONNECTION 
          AND GO TO A STATE WHERE IT WILL PROCESS THE CONNECTION- 
          CLOSED RESPONSE CORRECTLY.
  
          CMP 05/88  FFSLFLH. 
  
 TTNA111  FTP DOES NOT VALIDATE USER FOR FILE TRANSFER PERMISSIONS
  
          THIS MODSET CAUSES *FTPI* TO PERFORM VALIDATION OF THE LOCAL
          USER FOR REMOTE HOST FILE TRANSFER PERMISSION. THE PROTOCOL 
          BETWEEN *FTP* AND *FTPI* IS CHANGED TO MAKE USE OF THE
          NORMAL / ABNORMAL BIT IN THE CONNECT LOCAL RESPONSE BLOCK.
  
          CJR/CMP        88/06/06       COMAPDT,FCSIINI,FFSLCSH,FFSLCRP,
                                        FFSLFLH,FFSLTIP,FFSUVUI,TEXTFFS.
  
  
 TTNA113  A CHARGE,* WAS CAUSING FTPI TO ABORT. THIS WAS DUE TO THE FACT
          THAT FTPI WAS BEING FORCED TO PROCESS A CHARGE EVEN THOUGH
          THE USER HAD CCNR SET TO TRUE. THE FIX IS A SIMPLE CHANGE TO
          THE "STATES" ALLOWED THRU THE CHARGE PROCESSING MODULE. 
  
          CMP 06/88  FFSUVUC. 
  
 TTNA090  GET_FILE CREATES A FILE EVEN IF COMMAND FAILS 
  
          FTP IN BATCH MODE WILL NOW ABORT WHENEVER A COMMAND 
          FAILS. THE SITUATION ABOVE WILL STILL OCCUR BUT IS
          ACCEPTABLE AS LONG AS THE BATCH USER CAN DETECT 
          COMMAND FAILURE.
  
          CJR            88/06/08       FCSCPES 
  
 TTNA116  FTPI SHOULD NOT TERMINATE NORMALLY UPON CON/CB ON 
          DATA OR CONTROL CONNECTION. 
  
          CORRECTIVE CODE IS TO ABORT FTPI UPON CON/CB ON DATA
          OR CONTROL CONNECTION.  THIS ENABLES FTPI TO GO 
          THROUGH REPRIEVE PROCESSING SO THAT ONE CAN INVESTIGATE 
          WHAT IS GOING ON THE NETWORK. 
  
          AML            06/16/88       FFSLCSH 
  
 TTNA117  FTP HAS TYPE OF ASCII WHILE REMOTE HOST HAS TYPE OF IMAGE 
  
          IF THE DISPLAY_DIRECTORY OR DISPLAY_FILE_NAME COMMAND IS
          PROCESSED WHILE THE TRANSFER TYPE IS SET TO IMAGE AND A 
          NEGATIVE RESPONSE IS RECEIVED, THEN FTP WILL RESET THE
          TRANSFER TYPE OF THE REMOTE HOST TO IMAGE BUT WILL NOT
          RESET THE TRANSFER TYPE OF *FTPI* TO IMAGE. 
  
          CJR            88/06/16       FCSBDFN 
  
 TTNA118 PROBLEM  - FTPS ABORTED WITH MESSAGE 
                     "FTPS-RESUME DATA RECEIVE IN WRONG STATE"
         SOLUTION - THIS HAPPENED DUE TO SOME INCONSISTENCY 
                    BETWEEN THE NAM LAYER AND THE CONNECTION- 
                    MANAGEMENT LAYER AS TO WHEN TO ISSUE THE
                    LST/ON, LST/OFF. THE INCONSISTENCY IS NOW 
                    RESOLVED. 
  
         TET    06/17/88     FFSBCNE, FFSLCSH 
  
 TTNA119  FTPI ABORTS - FFSLTIP STATE HANDLER STATE = 9 TRIGGER = 1 
  
          THIS IS CAUSED BY THE FTP LAYER HANDLER TRYING TO ABORT 
          THE DATA CONNECTION IN RESPONSE TO THE ABORT REQUEST
          FROM CONTROL STATEMENT. 
          CORRECTIVE CODE IS TO CLOSE THE DATA CONNECTION IN LIEU 
          OF ABORTING IT. 
  
          AML            06/20/88       FFSLFLH 
  
 TTNA121  PSR TTNA118 FIXED THE CASE OF AN ATTEMPT TO LST/ON THE CONTROL
          CONNECTION WHEN IT WAS NOT IN A STATE TO BE LISTED ON.
          HOWEVER IT CAUSED PROBLEMS FOR THE CASE WHEN THE CONTROL
          STATEMENT CONNECTION IS TO BE LISTED ON.
          CODE HAS BEEN AMENDED TO ONLY TRY TO LST/ON THE C/S CONNECTION
          AS WAS DONE BEFORE VIZ. WHEN A NON-ZERO TCP STATE EXISTS. 
  
          CMP 06/88  FFSBCNE. 
  
 TTNA123  FTPI ABORTS - FFSLTIP STATE = 6, TRIGGER = 13.
  
          THIS IS CAUSED BY THE FTP LAYER TRYING TO CLOSE 
          THE DATA CONNECTION BEFORE IT IS ESTABLISHED IN 
          RESPONSE TO AN ABORT DATA TRANSFER INDICATION.
          FTP LAYER IS MODIFIED TO ABORT THE DATA CONNECTION
          IN LIEU OF CLOSING IT.
  
          AML            06/23/88       TEXTFFS,FFSIIPV,FFSLFLH 
  
         * * *   E N D   O F   H I S T O R Y   * * *
